<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:p="http://primefaces.org/ui"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core" 
                template="/WEB-INF/templates/LoggedTemplate.xhtml">

    <ui:define name="contentPart">       

        <h:form id="formCFDI">
            <h:outputText 
                value="Nómina -> CFDI" 
                style="font-weight: bold"/>

            <hr class="ui-separator ui-state-default ui-corner-all separator"></hr>            
            <h:outputText value="Generación de archivos XML" />
            <br/><br/>

            <div align="center">
                <h:panelGrid 
                    id="pnlCFDI" 
                    columns="4"
                    columnClasses="centered,centered2,centered,centered2"
                    cellpadding="5"
                    >


                    <p:outputLabel value="Periodo de nómina: "  style="font-weight: bold"/>

                    <p:outputLabel  value="#{rhNomnCFDIMB.ejercicioNomina.valor}" />                                             

                    <p:outputLabel value="Nombre de la nómina:" style="font-weight: bold"/>

                    <p:outputLabel lang="50" value="#{rhNomnCFDIMB.cabeceraNominaSelected.strNombreNomina}"  />

                    <p:outputLabel value="Total de archivos:" style="font-weight: bold"/>

                    <p:outputLabel value="1"  />

                    <p:outputLabel value="Total de empleados:" style="font-weight: bold"/>

                    <p:outputLabel  value="#{rhNomnCFDIMB.cabeceraNominaSelected.intCantidadEmpleadosNomina}" />
                </h:panelGrid>



                <h:panelGrid                 
                    columns="4"
                    columnClasses="centered5,centered6,centered5,centered6"
                    cellpadding="5"
                    >                     
                    <p:column>
                        <p:commandButton 
                            rendered="#{rhNomnCFDIMB.flagCrear}"
                            id="btnCrear" 
                            actionListener="#{rhNomnCFDIMB.crearCFDI(1)}"
                            title="CREAR CFDI"
                            value="CREAR CDFI"                                                                             
                            style="text-align:center" 
                            update="@all"/>

                    </p:column>

                </h:panelGrid>
            </div> 
            <br/>

            <div id="adminCFDI1" >
                <h:form enctype="multipart/form-data" class="form">
                    <p:dataTable var="cfdi" 
                                 class="adminCFDI" 
                                 value="#{rhNomnCFDIMB.lstCFDIProcesados}"
                                 paginatorTemplate="{CurrentPageReport} {RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {PageLinks} {NextPageLink} {LastPageLink}"
                                 scrollable="true" 
                                 scrollWidth="99%"
                                 paginator="true"
                                 rowIndexVar="rowIndex"
                                 rows="5"  
                                 rowsPerPageTemplate="5,10,15"
                                 currentPageReportTemplate="Mostrando del {startRecord} al {endRecord} de {totalRecords}."
                                 paginatorPosition="bottom"                 
                                 emptyMessage="#{msg['inai.medios.common.noRecordsText']}"
                                 style="font-size: small; width: 95%"
                                 rendered="#{!rhNomnCFDIMB.flagCrear}"
                                 resizableColumns="false"
                                 >
                        <f:facet name="header">
                            Administración CFDI
                        </f:facet>
                        <p:column headerText="FECHA"
                                  style="width: 14%;">
                            <h:outputText value="#{cfdi.fechaProceso}" >
                                <f:convertDateTime pattern="dd/MM/yyyy" />
                            </h:outputText>
                        </p:column>
                        <p:column headerText="EMITIDOS"
                                  style="width: 14%;">
                            <h:outputText value="#{cfdi.emitidos}" />
                        </p:column>
                        <p:column headerText="TIMBRADOS"
                                  style="width: 14%;">
                            <h:outputText value="#{cfdi.timbrados}" />
                        </p:column>
                        <p:column headerText="NO TIMBRADO"
                                  style="width: 14%;">
                            <h:outputText value="#{cfdi.emitidos - cfdi.timbrados}" />
                        </p:column>
                        <p:column headerText="CANCELADOS"
                                  style="width: 14%;">
                            <h:outputText value="#{cfdi.cancelados}" />
                        </p:column>
                        <p:column headerText="POR CANCELAR"
                                  style="width: 14%;">
                            <h:outputText value="#{cfdi.pendientes}" />
                        </p:column>
                        <p:column headerText="ACCIONES"
                                  style="width: 13%;">
                            <p:fileUpload 
                                mode="advanced"
                                class="subirArchivoCFDI"
                                auto="true"
                                id="subirTimbrado"
                                fileUploadListener="#{rhNomnCFDIMB.archivoTimbrado}"
                                label="Subir Archivo"
                                invalidFileMessage="El archivo no es valido"
                                skinSimple="true"
                                process="@(.form)"
                                update="@(.adminCFDI)"
                                rendered="#{cfdi.idCFDITIMB == null and rowIndex == rhNomnCFDIMB.lstCFDIProcesados.size()-1 }"
                                allowTypes="/(\.|\/)(xml|xml\.p7m)$/"
                                >
                                <f:attribute name="cfdi" value="#{cfdi}" />
                            </p:fileUpload>


                            <p:fileUpload 
                                mode="advanced"
                                class="subirArchivoCFDI"
                                auto="true"
                                id="actualizaTimbrado"
                                fileUploadListener="#{rhNomnCFDIMB.archivoTimbrado}"
                                label="Actualizar Archivo"
                                invalidFileMessage="El archivo no es valido"
                                skinSimple="true"
                                process="@(.form)"
                                update="@(.adminCFDI)"
                                rendered="#{cfdi.idCFDITIMB != null and rowIndex == rhNomnCFDIMB.lstCFDIProcesados.size()-1 }"
                                allowTypes="/(\.|\/)(xml|xml\.p7m)$/"
                                >
                                <f:attribute name="cfdi" value="#{cfdi}" />
                            </p:fileUpload>


                            <p:commandButton value="Detalle"
                                             actionListener="#{rhNomnCFDIMB.detalle(cfdi)}"
                                             oncomplete="PF('detalleCFDI').show()"
                                             style="font-size: x-small; width:75% ;margin-top: -5%;"
                                             update="@(.detalleCFDI)"
                                             rendered="#{cfdi.timbrados != null and cfdi.timbrados > 0 and rowIndex == rhNomnCFDIMB.lstCFDIProcesados.size()-1 }"
                                             />
                            <p:commandButton value="Generar CFDI"
                                             actionListener="#{rhNomnCFDIMB.crearCFDI(2)}"
                                             style="font-size: x-small; width:75%;margin-top: 2% "
                                             update="@all"
                                             rendered="#{((cfdi.emitidos-cfdi.timbrados) > 0 or cfdi.cancelados > 0) and cfdi.timbrados > 0  and rowIndex == rhNomnCFDIMB.lstCFDIProcesados.size()-1 }"
                                             />
                            <p:commandButton 
                                id="btnDescargar"
                                actionListener="#{rhNomnCFDIMB.getFileDownload(cfdi.idCFDI)}"
                                value="Descargar CFDI"  title="DESCARGA CFDI"
                                ajax="false"
                                style="font-size: x-small; width:75%;margin-top: 2% ;"
                                rendered="#{cfdi.timbrados >=0 and rowIndex == rhNomnCFDIMB.lstCFDIProcesados.size()-1 }"
                                >
                                <p:fileDownload value="#{rhNomnCFDIMB.getFileDownload(cfdi.idCFDI)}" />
                            </p:commandButton>
                        </p:column>

                    </p:dataTable>    

                </h:form>

            </div>

            <div align="right" style="padding-right: 10px">
                <p:commandButton 
                    id="btnRegresar" 
                    process="btnRegresar"
                    value="Regresar" 
                    title="Regresar" 
                    style="font-size: 70%;                                        
                    text-align:center"
                    actionListener="#{rhNomnCFDIMB.regresar}">
                </p:commandButton>
            </div>

        </h:form>

        <p:dialog widgetVar="detalleCFDI"
                  id="detalleCFDI"
                  class="detalleCFDI"
                  appendTo ="@(body)" 
                  dynamic="false" 
                  modal="true"
                  draggable="false"
                  closable="true" 
                  position="top"
                  closeOnEscape="true"
                  resizable="false"
                  header="Detalle CFDI"
                  style="position: absolute ; margin-top: 2%; min-height: 87%;max-height: 87%; min-width:90%;max-width:90%; overflow: auto; "
                  >
            <h:form>
                <p:tabView id="tabviewDetalle" 
                           dynamic="true"
                           style="font-size: small; min-height: 100%; max-height: 100%; overflow: auto; "

                           >    
                    <p:ajax event="tabChange" listener="#{rhNomnCFDIMB.onTabChange}" />
                    <p:tab id="idexitosos" 
                           title="Exitosos"

                           >
                        <div id="idTabExitosos" style="min-height: 400px; max-height: 400px; overflow: auto">
                            <p:dataTable 
                                widgetVar="dataTableWV"
                                var="exitososCFDI" 
                                class="exitososCFDI"
                                paginator="true"                                         
                                rowKey="#{exitososCFDI.UUID}"
                                value="#{rhNomnCFDIMB.lstDetalleCFDI}"
                                selection="#{rhNomnCFDIMB.lstCancelarCFDI}"
                                paginatorTemplate="{CurrentPageReport} {RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {PageLinks} {NextPageLink} {LastPageLink}"                         
                                scrollable="true" 
                                rows="10"  
                                rowsPerPageTemplate="5,10,15"
                                currentPageReportTemplate="Mostrando del {startRecord} al {endRecord} de {totalRecords}."
                                paginatorPosition="bottom"                 
                                emptyMessage="#{msg['inai.medios.common.noRecordsText']}"
                                style="font-size: small;"
                                >
                                <p:ajax event="toggleSelect" 
                                        listener="#{rhNomnCFDIMB.selectUnselectall}"
                                        process="@this" />
                                <p:column 
                                    headerText="#{translatedMessage['restricted.nomina.calculaNomina.seleccionarTodo']}"
                                    style="width:10%; text-align: center;"
                                    selectionMode="multiple"

                                    >

                                </p:column>
                                <p:column headerText="NUMERO EMPLEADO"
                                          filterBy="#{exitososCFDI.NUMEMP}"
                                          filterMatchMode="contains"
                                          style="width: 20%;">
                                    <h:outputText value="#{exitososCFDI.NUMEMP}" />
                                </p:column>
                                <p:column headerText="RFC"
                                          filterBy="#{exitososCFDI.RFC}"
                                          filterMatchMode="contains"
                                          style="width: 25%;">
                                    <h:outputText value="#{exitososCFDI.RFC}" />
                                </p:column>
                                <p:column headerText="UUID"
                                          filterBy="#{exitososCFDI.UUID}"
                                          filterMatchMode="contains"
                                          style="width: 40%;">
                                    <h:outputText value="#{exitososCFDI.UUID}" />
                                </p:column>

                            </p:dataTable>
                        </div>
                        <div style="text-align: right; " >
                            <p:commandButton 
                                id="btnCancelar"
                                ajax="false"
                                actionListener="#{rhNomnCFDIMB.cancelarCFDI()}"
                                value="GENERAR ARCHIVO CANCELAR CFDI"  title="CANCELAR CFDI"
                                style="font-size: small; text-align:center; margin-top: 1%;">
                            </p:commandButton>    
                        </div>
                    </p:tab>

                    <p:tab id="idPendientes" title="Pendientes">
                        <div id="idTabPendientes" style="min-height: 400px; max-height: 400px; overflow: auto">
                            <p:dataTable 
                                id="dataTablePendiente"
                                widgetVar="dataTablePendiente"
                                var="pendienteCFDI" 
                                class="pendienteCFDI"
                                paginator="true"                                         
                                rowKey="#{pendienteCFDI.UUID}"
                                value="#{rhNomnCFDIMB.lstCancelacionesPendientes}"
                                paginatorTemplate="{CurrentPageReport} {RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {PageLinks} {NextPageLink} {LastPageLink}"                         
                                scrollable="true" 
                                rows="10"  
                                rowsPerPageTemplate="5,10,15"
                                currentPageReportTemplate="Mostrando del {startRecord} al {endRecord} de {totalRecords}."
                                paginatorPosition="bottom"                 
                                emptyMessage="#{msg['inai.medios.common.noRecordsText']}"
                                style="font-size: small;min-width: 70%;max-width: 70%;"
                                >
                                <p:column headerText="NUMERO EMPLEADO"
                                          filterMatchMode="contains"
                                          filterBy="#{pendienteCFDI.numEmp}"
                                          style="width: 20%"
                                          >
                                    <h:outputText value="#{pendienteCFDI.numEmp}" />
                                </p:column>
                                <p:column headerText="UUID"
                                          filterMatchMode="contains"
                                          filterBy="#{pendienteCFDI.UUID}"
                                          >
                                    <h:outputText value="#{pendienteCFDI.UUID}" />
                                </p:column>
                                <p:column headerText="ACCIONES"
                                          style="width: 10%">
                                    <p:commandButton 
                                        id="btnQuitar"
                                        ajax="false"
                                        value="Quitar UUID"  title="Quitar UUID"
                                        actionListener="#{rhNomnCFDIMB.quitarUUID(pendienteCFDI.UUID)}"
                                        process="@(.form)"
                                        update="@(.adminCFDI) @(.canceladosCFDI) @(.pendienteCFDI) @(.exitososCFDI)"
                                        oncomplete="PF('detalleCFDI').show()"
                                        style="font-size: x-small; margin-bottom: -1%">
                                    </p:commandButton>  
                                </p:column>

                            </p:dataTable>
                        </div>
                    </p:tab>
                    <p:tab id="idCancelados" title="Cancelados">
                        <div id="idTabCancelados" style="min-height: 400px; max-height: 400px; overflow: auto">
                            <p:dataTable 
                                widgetVar="dataTableCancelados"
                                var="canceladosCFDI" 
                                class="canceladosCFDI"
                                paginator="true"                                         
                                rowKey="#{canceladosCFDI.UUID}"
                                value="#{rhNomnCFDIMB.lstCancelaciones}"
                                paginatorTemplate="{CurrentPageReport} {RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {PageLinks} {NextPageLink} {LastPageLink}"                         
                                scrollable="true" 
                                rows="10"  
                                rowsPerPageTemplate="5,10,15"
                                currentPageReportTemplate="Mostrando del {startRecord} al {endRecord} de {totalRecords}."
                                paginatorPosition="bottom"                 
                                emptyMessage="#{msg['inai.medios.common.noRecordsText']}"
                                style="font-size: small; min-width: 70%;max-width: 70%;"
                                >

                                <p:column headerText="NUMERO EMPLEADO"
                                          filterMatchMode="contains"
                                          filterBy="#{canceladosCFDI.numEmp}"
                                          >
                                    <h:outputText value="#{canceladosCFDI.numEmp}" />
                                </p:column>
                                <p:column headerText="UUID"
                                          filterBy="#{canceladosCFDI.UUID}"
                                          filterMatchMode="contains"
                                          style="width: 40%;">
                                    <h:outputText value="#{canceladosCFDI.UUID}" />
                                </p:column>

                            </p:dataTable>
                        </div>
                    </p:tab>
                    <p:tab id="idArchivos" title="Archivos" >
                        <div id="idTabArchivos" style="min-height: 400px; max-height: 400px; overflow: auto">
                            <p:dataTable 
                                widgetVar="dataTableCancelados"
                                var="archivosCFDI" 
                                class="archivosCFDI"
                                paginator="true"                                         
                                rowIndexVar="numLinea"
                                value="#{rhNomnCFDIMB.lstIdArchivosDescarga}"
                                paginatorTemplate="{CurrentPageReport} {RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {PageLinks} {NextPageLink} {LastPageLink}"                         
                                scrollable="true" 
                                rows="10"  
                                rowsPerPageTemplate="5,10,15"
                                currentPageReportTemplate="Mostrando del {startRecord} al {endRecord} de {totalRecords}."
                                paginatorPosition="bottom"                 
                                emptyMessage="#{msg['inai.medios.common.noRecordsText']}"
                                style="font-size: small; min-width: 40%;max-width: 40%;"
                                >
                                <p:column headerText="Archivos Pendientes"
                                          style="width: 50%;">
                                    <p:commandButton 
                                        id="btnCancelar"
                                        ajax="false"
                                        value="Descargar Archivo #{numLinea+1}"  title="Descargar"
                                        actionListener="#{rhNomnCFDIMB.descargarArchivo(archivosCFDI['ID_CFDI_CANCELADO'])}"
                                        style="font-size: x-small; margin-bottom: -1%">
                                        <p:fileDownload value="#{rhNomnCFDIMB.archivo}" />
                                    </p:commandButton>  

                                </p:column>
                                <p:column headerText="Acciones"
                                          style="width: 50%;">
                                    <p:fileUpload 
                                        mode="advanced"
                                        class="subirArchivoCFDI"
                                        auto="true"
                                        id="actualizaTimbrado"
                                        fileUploadListener="#{rhNomnCFDIMB.archivoCancelado}"
                                        label="#{archivosCFDI['ESTATUS']== 0?'Subir Archivo':'Actualizar'}"
                                        invalidFileMessage="El archivo no es valido"
                                        skinSimple="true"
                                        process="@(.form)"
                                        update="@(.adminCFDI) @(.canceladosCFDI) @(.pendienteCFDI) @(.exitososCFDI)"
                                        allowTypes="/(\.|\/)(xml|xml\.p7m)$/"
                                        >
                                        <f:attribute name="idCancelado" value="#{archivosCFDI['ID_CFDI_CANCELADO']}" />
                                    </p:fileUpload>    
                                </p:column>

                            </p:dataTable>
                        </div>
                    </p:tab>
                </p:tabView>
            </h:form>
        </p:dialog>

    </ui:define>
</ui:composition>